1 #
   2 # Copyright (c) 2006, 2012, Oracle and/or its affiliates. All rights reserved.
   3 # DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
   4 #
   5 # This code is free software; you can redistribute it and/or modify it
   6 # under the terms of the GNU General Public License version 2 only, as
   7 # published by the Free Software Foundation.
   8 #
   9 # This code is distributed in the hope that it will be useful, but WITHOUT
  10 # ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  11 # FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  12 # version 2 for more details (a copy is included in the LICENSE file that
  13 # accompanied this code).
  14 #
  15 # You should have received a copy of the GNU General Public License version
  16 # 2 along with this work; if not, write to the Free Software Foundation,
  17 # Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
  18 #
  19 # Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
  20 # or visit www.oracle.com if you need additional information or have any
  21 # questions.
  22 #
  23 
  24 # @test
  25 # @summary (almost) all keytool behaviors
  26 # @author Weijun Wang
  27 #
  28 # This test is only executed on several platforms
  29 #
  30 # set a few environment variables so that the shell-script can run stand-alone
  31 # in the source directory
  32 if [ "${TESTSRC}" = "" ] ; then
  33   TESTSRC="."
  34 fi
  35 if [ "${TESTCLASSES}" = "" ] ; then
  36   TESTCLASSES="."
  37 fi
  38 if [ "${TESTJAVA}" = "" ] ; then
  39   echo "TESTJAVA not set.  Test cannot execute."
  40   echo "FAILED!!!"
  41   exit 1
  42 fi
  43 
  44 find_one() {
  45   for TARGET_FILE in $@; do
  46     if [ -e "$TARGET_FILE" ]; then
  47       echo $TARGET_FILE
  48       return
  49     fi
  50   done
  51 }
  52 
  53 # set platform-dependent variables
  54 OS=`uname -s`
  55 case "$OS" in
  56   SunOS )
  57     FS="/"
  58     LIBNAME="/usr/lib/mps/libsoftokn3.so"
  59     ;;
  60   Linux )
  61     FS="/"
  62     ${TESTJAVA}${FS}bin${FS}java -XshowSettings:properties -version 2> allprop
  63     cat allprop | grep os.arch | grep 64
  64     if [ "$?" != "0" ]; then
  65         LIBNAME=`find_one \
  66             "/usr/lib/libsoftokn3.so" \
  67             "/usr/lib/i386-linux-gnu/nss/libsoftokn3.so"`
  68     else
  69         LIBNAME=`find_one \
  70             "/usr/lib64/libsoftokn3.so" \
  71             "/usr/lib/x86_64-linux-gnu/nss/libsoftokn3.so"`
  72     fi
  73     ;;
  74   * )
  75     echo "Will not run test on: ${OS}"
  76     exit 0;
  77     ;;
  78 esac
  79 
  80 if [ "$LIBNAME" = "" ]; then
  81   echo "Cannot find libsoftokn3.so"
  82   exit 1
  83 fi
  84 
  85 ${TESTJAVA}${FS}bin${FS}javac -d . -XDignore.symbol.file \
  86         ${TESTSRC}${FS}KeyToolTest.java || exit 10
  87 
  88 NSS=${TESTSRC}${FS}..${FS}..${FS}pkcs11${FS}nss
  89 
  90 cp ${TESTSRC}${FS}p11-nss.txt .
  91 cp ${NSS}${FS}db${FS}cert8.db .
  92 cp ${NSS}${FS}db${FS}key3.db .
  93 cp ${NSS}${FS}db${FS}secmod.db .
  94 
  95 chmod u+w key3.db
  96 chmod u+w cert8.db
  97 
  98 echo | ${TESTJAVA}${FS}bin${FS}java -Dnss \
  99    -Dnss.lib=${LIBNAME} \
 100    KeyToolTest
 101 status=$?
 102 
 103 rm -f p11-nss.txt
 104 rm -f cert8.db
 105 rm -f key3.db
 106 rm -f secmod.db
 107 
 108 rm HumanInputStream*.class
 109 rm KeyToolTest*.class
 110 rm TestException.class
 111 
 112 exit $status